clang 8.0.0

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::AttributedStmt Class Referencefinal

Represents an attribute applied to a statement. More...

`#include "clang/AST/Stmt.h"`

Inheritance diagram for clang::AttributedStmt:
[legend]
Collaboration diagram for clang::AttributedStmt:
[legend]

## Public Member Functions
SourceLocation | getAttrLoc () const
ArrayRef< const Attr * > | getAttrs () const
Stmt * | getSubStmt ()
const Stmt * | getSubStmt () const
SourceLocation | getBeginLoc () const
SourceLocation | getEndLoc () const LLVM_READONLY
child_range | children ()
Public Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes, const ASTContext &C, unsigned alignment=8)
void * | operator new (size_t bytes, const ASTContext *C, unsigned alignment=8)
void * | operator new (size_t bytes, void *mem) noexcept
void | operator delete (void *, const ASTContext &, unsigned) noexcept
void | operator delete (void *, const ASTContext *, unsigned) noexcept
void | operator delete (void *, size_t) noexcept
void | operator delete (void *, void *) noexcept
| Stmt (StmtClass SC)
StmtClass | getStmtClass () const
const char * | getStmtClassName () const
SourceRange | getSourceRange () const LLVM_READONLY
| SourceLocation tokens are not useful in isolation - they are low level value objects created/interpreted by SourceManager. More...
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
void | dump () const
| Dumps the specified AST fragment and all subtrees to `llvm::errs()`. More...
void | dump (SourceManager &SM) const
void | dump (raw_ostream &OS, SourceManager &SM) const
void | dump (raw_ostream &OS) const
int64_t | getID (const ASTContext &Context) const
void | dumpColor () const
| dumpColor - same as dump(), but forces color highlighting. More...
void | dumpPretty (const ASTContext &Context) const
| dumpPretty/printPretty - These two methods do a "pretty print" of the AST back to its original source language syntax. More...
void | printPretty (raw_ostream &OS, PrinterHelper *Helper, const PrintingPolicy &Policy, unsigned Indentation=0, StringRef NewlineSymbol="\, const ASTContext *Context=nullptr) const
void | viewAST () const
| viewAST - Visualize an AST rooted at this Stmt* using GraphViz. More...
Stmt * | IgnoreImplicit ()
| Skip past any implicit AST nodes which might surround this statement, such as ExprWithCleanups or ImplicitCastExpr nodes. More...
const Stmt * | IgnoreImplicit () const
Stmt * | IgnoreContainers (bool IgnoreCaptured=false)
| Skip no-op (attributed, compound) container stmts and skip captured stmt at the top, if IgnoreCaptured is true. More...
const Stmt * | IgnoreContainers (bool IgnoreCaptured=false) const
const Stmt * | stripLabelLikeStatements () const
| Strip off all label-like statements. More...
Stmt * | stripLabelLikeStatements ()
child_range | children ()
const_child_range | children () const
child_iterator | child_begin ()
child_iterator | child_end ()
const_child_iterator | child_begin () const
const_child_iterator | child_end () const
void | Profile (llvm::FoldingSetNodeID &ID, const ASTContext &Context, bool Canonical) const
| Produce a unique representation of the given statement. More...
void | ProcessODRHash (llvm::FoldingSetNodeID &ID, ODRHash &Hash) const
| Calculate a unique representation for a statement that is stable across compiler invocations. More...

## Static Public Member Functions
static AttributedStmt * | Create (const ASTContext &C, SourceLocation Loc, ArrayRef< const Attr *> Attrs, Stmt *SubStmt)
static AttributedStmt * | CreateEmpty (const ASTContext &C, unsigned NumAttrs)
static bool | classof (const Stmt *T)
Static Public Member Functions inherited from clang::Stmt
static void | addStmtClass (const StmtClass s)
static void | EnableStatistics ()
static void | PrintStats ()

## Friends
class | ASTStmtReader

## Additional Inherited Members
Public Types inherited from clang::Stmt
enum | StmtClass { NoStmtClass = 0 }
using | child_iterator = StmtIterator
| Child Iterators: All subclasses must implement 'children' to permit easy iteration over the substatements/subexpessions of an AST node. More...
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Types inherited from clang::Stmt
enum | { NumStmtBits = 8 }
enum | { NumExprBits = NumStmtBits + 9 }
enum | APFloatSemantics { IEEEhalf, IEEEsingle, IEEEdouble, x87DoubleExtended, IEEEquad, PPCDoubleDouble }
enum | { NumCallExprBits = 32 }
enum | { NumOverloadExprBits = NumExprBits + 1 }
Protected Member Functions inherited from clang::Stmt
void * | operator new (size_t bytes) noexcept
void | operator delete (void *data) noexcept
| Stmt (StmtClass SC, EmptyShell)
| Construct an empty statement. More...
Protected Attributes inherited from clang::Stmt
union {
StmtBitfields StmtBits
NullStmtBitfields NullStmtBits
CompoundStmtBitfields CompoundStmtBits
LabelStmtBitfields LabelStmtBits
AttributedStmtBitfields AttributedStmtBits
IfStmtBitfields IfStmtBits
SwitchStmtBitfields SwitchStmtBits
WhileStmtBitfields WhileStmtBits
DoStmtBitfields DoStmtBits
ForStmtBitfields ForStmtBits
GotoStmtBitfields GotoStmtBits
ContinueStmtBitfields ContinueStmtBits
BreakStmtBitfields BreakStmtBits
ReturnStmtBitfields ReturnStmtBits
SwitchCaseBitfields SwitchCaseBits
ExprBitfields ExprBits
PredefinedExprBitfields PredefinedExprBits
DeclRefExprBitfields DeclRefExprBits
FloatingLiteralBitfields FloatingLiteralBits
StringLiteralBitfields StringLiteralBits
CharacterLiteralBitfields CharacterLiteralBits
UnaryOperatorBitfields UnaryOperatorBits
UnaryExprOrTypeTraitExprBitfields UnaryExprOrTypeTraitExprBits
ArraySubscriptExprBitfields ArraySubscriptExprBits
CallExprBitfields CallExprBits
MemberExprBitfields MemberExprBits
CastExprBitfields CastExprBits
BinaryOperatorBitfields BinaryOperatorBits
InitListExprBitfields InitListExprBits
ParenListExprBitfields ParenListExprBits
PseudoObjectExprBitfields PseudoObjectExprBits
CXXOperatorCallExprBitfields CXXOperatorCallExprBits
CXXBoolLiteralExprBitfields CXXBoolLiteralExprBits
CXXNullPtrLiteralExprBitfields CXXNullPtrLiteralExprBits
CXXThisExprBitfields CXXThisExprBits
CXXThrowExprBitfields CXXThrowExprBits
CXXDefaultArgExprBitfields CXXDefaultArgExprBits
CXXDefaultInitExprBitfields CXXDefaultInitExprBits
CXXScalarValueInitExprBitfields CXXScalarValueInitExprBits
CXXNewExprBitfields CXXNewExprBits
CXXDeleteExprBitfields CXXDeleteExprBits
TypeTraitExprBitfields TypeTraitExprBits
DependentScopeDeclRefExprBitfields DependentScopeDeclRefExprBits
CXXConstructExprBitfields CXXConstructExprBits
ExprWithCleanupsBitfields ExprWithCleanupsBits
CXXUnresolvedConstructExprBitfields CXXUnresolvedConstructExprBits
CXXDependentScopeMemberExprBitfields CXXDependentScopeMemberExprBits
OverloadExprBitfields OverloadExprBits
UnresolvedLookupExprBitfields UnresolvedLookupExprBits
UnresolvedMemberExprBitfields UnresolvedMemberExprBits
CXXNoexceptExprBitfields CXXNoexceptExprBits
SubstNonTypeTemplateParmExprBitfields SubstNonTypeTemplateParmExprBits
CoawaitExprBitfields CoawaitBits
ObjCIndirectCopyRestoreExprBitfields ObjCIndirectCopyRestoreExprBits
OpaqueValueExprBitfields OpaqueValueExprBits
}; |

## Detailed Description

Represents an attribute applied to a statement.

Represents an attribute applied to a statement. For example: [[omp::for(...)]] for (...) { ... }

Definition at line 1633 of file Stmt.h.

## Member Function Documentation

## ◆ children()

child_range clang::AttributedStmt::children | ( |  | ) |
| inline

Definition at line 1679 of file Stmt.h.

## ◆ classof()

static bool clang::AttributedStmt::classof | ( | const Stmt * | T | ) |
| inline static

Definition at line 1681 of file Stmt.h.

References clang::Stmt::getStmtClass().

## ◆ Create()

AttributedStmt * AttributedStmt::Create | ( | const ASTContext & | C,
|  | SourceLocation | Loc,
|  | ArrayRef< const Attr *> | Attrs,
|  | Stmt * | SubStmt
| ) |  |
| static

Definition at line 352 of file Stmt.cpp.

References clang::ASTContext::Allocate().

Referenced by clang::Sema::ActOnAttributedStmt().

## ◆ CreateEmpty()

AttributedStmt * AttributedStmt::CreateEmpty | ( | const ASTContext & | C,
|  | unsigned | NumAttrs
| ) |  |
| static

Definition at line 361 of file Stmt.cpp.

References clang::ASTContext::Allocate().

## ◆ getAttrLoc()

SourceLocation clang::AttributedStmt::getAttrLoc | ( |  | ) | const
| inline

Definition at line 1668 of file Stmt.h.

Referenced by clang::TreeTransform< Derived >::TransformAttr().

## ◆ getAttrs()

ArrayRef<const Attr *> clang::AttributedStmt::getAttrs | ( |  | ) | const
| inline

Definition at line 1669 of file Stmt.h.

Referenced by clang::TreeTransform< Derived >::TransformAttr().

## ◆ getBeginLoc()

SourceLocation clang::AttributedStmt::getBeginLoc | ( |  | ) | const
| inline

Definition at line 1676 of file Stmt.h.

References getAttrLoc().

## ◆ getEndLoc()

SourceLocation clang::AttributedStmt::getEndLoc | ( |  | ) | const
| inline

Definition at line 1677 of file Stmt.h.

References clang::Stmt::getEndLoc().

## ◆ getSubStmt() [1/2]

Stmt* clang::AttributedStmt::getSubStmt | ( |  | ) |
| inline

Definition at line 1673 of file Stmt.h.

Referenced by clang::TreeTransform< Derived >::TransformAttr().

## ◆ getSubStmt() [2/2]

const Stmt* clang::AttributedStmt::getSubStmt | ( |  | ) | const
| inline

Definition at line 1674 of file Stmt.h.

## Friends And Related Function Documentation

## ◆ ASTStmtReader

friend class ASTStmtReader
| friend

Definition at line 1636 of file Stmt.h.

The documentation for this class was generated from the following files:

- include/clang/AST/Stmt.h
- lib/AST/Stmt.cpp